# Summary

* [前言](README.md)
* [Python代码规范](/Article/codeSpecification/codeSpecification_Preface.md)
  - [简明概述](/Article/codeSpecification/codeSpecification_first.md)
  - [注释](/Article/codeSpecification/codeSpecification_second.md)
  - [命名规范](/Article/codeSpecification/codeSpecification_third.md)
* [第一个Python程序](/Article/python1/Preface.md)
  - [Python 简介](/Article/python1/Introduction.md)
  - [Python 的安装](/Article/python1/Installation.md)
  - [第一个 Python 程序](/Article/python1/The_first_procedure.md)
  - [集成开发环境（IDE）: PyCharm](/Article/python1/IDE.md)
* [基本数据类型和变量](/Article/python2/Preface.md)
  - [Python 语法的简要说明](/Article/python2/Grammar.md)
  - [Python 的基本数据类型](/Article/python2/Type_of_data.md)
  - [基本数据类型转换](/Article/python2/Type_conversion.md)
  - [Python 中的变量](/Article/python2/Variable.md)
* [List 和 Tuple](/Article/python3/Preface.md)
  - [List（列表）](/Article/python3/List.md)
  - [tuple（元组）](/Article/python3/tuple.md)
* [ Dict 和 Set](/Article/python4/Preface.md)
  - [字典(Dictionary)](/Article/python4/Dict.md)
  - [set](/Article/python4/Set.md)
* [条件语句和循环语句](/Article/python5/Preface.md)
  - [条件语句](/Article/python5/If.md)
  - [循环语句](/Article/python5/Cycle.md)
  - [条件语句和循环语句综合实例](/Article/python5/Example.md)
* [函数](/Article/python6/Preface.md)
  - [Python 自定义函数的基本步骤](/Article/python6/1.md)
  - [函数传值问题](/Article/python6/2.md)
  - [函数返回值](/Article/python6/3.md)
  - [函数的参数](/Article/python6/4.md)
  - [匿名函数](/Article/python6/5.md)
* [迭代器和生成器](/Article/python7/Preface.md)
  - [迭代](/Article/python7/1.md)
  - [Python 迭代器](/Article/python7/2.md)
  - [lsit 生成式（列表生成式）](/Article/python7/3.md)
  - [生成器](/Article/python7/4.md)
  - [迭代器和生成器综合例子](/Article/python7/5.md)
* [模块与包](/Article/python8/Preface.md)
  - [Python 模块简介](/Article/python8/1.md)
  - [模块的使用](/Article/python8/2.md)
  - [主模块和非主模块](/Article/python8/3.md)
  - [包](/Article/python8/4.md)
  - [作用域](/Article/python8/5.md)
* [面向对象](/Article/python9/Preface.md)
  - [面向对象的概念](/Article/python9/1.md)
  - [类](/Article/python9/2.md)
  - [类的属性](/Article/python9/3.md)
  - [类的方法](/Article/python9/4.md)
  - [类的继承](/Article/python9/5.md)
  - [类的多态](/Article/python9/6.md)
* [Python 的 Magic Method](/Article/python10/Preface.md)
  - [Python 的 Magic Method](/Article/python10/1.md)
  - [构造(`__new__`)和初始化(`__init__`)](/Article/python10/2.md)
  - [属性的访问控制](/Article/python10/3.md)
  - [对象的描述器](/Article/python10/4.md)
  - [自定义容器（Container）](/Article/python10/5.md)
  - [运算符相关的魔术方法](/Article/python10/6.md)
* [枚举类](/Article/python11/Preface.md)
  - [枚举类的使用](/Article/python11/1.md)
  - [Enum 的源码](/Article/python11/2.md)
  - [自定义类型的枚举](/Article/python11/3.md)
  - [枚举的比较](/Article/python11/4.md)
* [元类](/Article/python12/Preface.md)
  - [Python 中类也是对象](/Article/python12/1.md)
  - [使用 `type()` 动态创建类](/Article/python12/2.md)
  - [什么是元类](/Article/python12/3.md)
  - [自定义元类](/Article/python12/4.md)
  - [使用元类](/Article/python12/5.md)
* [线程与进程](/Article/python13/Preface.md)
  - [线程与进程](/Article/python13/1.md)
  - [多线程编程](/Article/python13/2.md)
  - [进程](/Article/python13/3.md)
* [一步一步了解正则表达式](/Article/python14/Preface.md)
    - [初识 Python 正则表达式](/Article/python14/1.md)
    - [字符集](/Article/python14/2.md)
    - [数量词](/Article/python14/3.md)
    - [边界匹配符和组](/Article/python14/4.md)
    - [re.sub](/Article/python14/5.md)
    - [re.match 和 re.search](/Article/python14/6.md)
* [闭包](/Article/python15/1.md)
* [装饰器](/Article/python16/1.md)
* [知识点补漏](README.md)
    - [Python 关键字 yield](/Article/supplement/Python关键字yield.md)
* [**Python 进阶部分**](/Article/advanced/advanced.md)
* [使用Python虚拟环境](/Article/advanced/使用Python虚拟环境.md)
* [Mac中使用virtualenv和virtualenvwrapper](/Article/advanced/Mac中使用virtualenv和virtualenvwrapper.md)
* [**Django**](/Article/django/Django.md)
